#!/usr/bin/env perl

my @types = qw(RT_SLOW ST_SLOW RT_FAST RT_SUPERFAST ST_SUPERFAST);

my $type = "";
my $group_seen = 0;
my @group;

sub print_json {
    return if ! $group_seen;
#    print "@group\n";
    print "\t{\"group\" : {\n";
    print "\t\t\"name\"        : \"$group[0][0]\",\n";
#    print "\t\t\"MIB_id\"      : \"$group[0][1]\",\n";
    print "\t\t\"source\"      : \"$group[0][2]\",\n";
    print "\t\t\"units\"       : \"$group[0][3]\",\n";
    print "\t\t\"subsystem\"   : \"$group[0][4]\",\n";
    print "\t\t\"OBS_id\"      : \"$group[0][5]\",\n";
    print "\t\t\"HK_name\"     : \"$group[0][6]\",\n";
    my $val = $group[0][7];
    my $str = ($val =~ /-/) ? '"-"' : $val;
    print "\t\t\"Min_val\"     : $str,\n";
    $val = $group[0][8];
    $str = ($val =~ /-/) ? '"-"' : $val;
    print "\t\t\"Max_val\"     : $str,\n";
#    print "\t\t\"plot_title_chomp\"  : 3\n";
    print "\t\t\"plot_legend_chomp\" : 2\n";    
    print "\t\t\"parameters\"  : [\n";

    while (@group) {
	my @g = shift @group;
	print "\t\t\t{";
	if (@group) {
	    print "\"name\":\"$g[0][0]\", \"MIB_id\" : \"$g[0][1]\"},\n";
	}
	else {
	    print "\"name\":\"$g[0][0]\", \"MIB_id\" : \"$g[0][1]\"}\n";
	}
    }

    print "\t\t]},\n";
    $group_seen = 0;
    @group = ();
}

sub save {
    my @line = @_;

    $group_seen = 1;

    push @group, [@line];
}

print "[\n";

while(<>) {

    next if /MIB ID/;
    next if /^$/;

    chomp;

    if ($_ ~~ @types) {
	print_json();
	$type = $_;
	$type = lc $type;
	print "type = $type\n";
	while(<>) {
	    next if /^$/;
	    chomp;
	    print_json() if /^---/;
	    next if /^---/;
	    last if /===/;
	    my @line = split /,/;
#	    print "LINE @line ($line[6])\n";
	    save(@line);
	    next;
	}
    }
    else {
	print "FOO $_\n";
    }
}

print "]\n";
